'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _toJs = require('to-js');

var _toJs2 = _interopRequireDefault(_toJs);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/// @name Base
/// @page api
/// @description
/// This holds the base functions that each of the classes in the application will exten
var Base = function (_Logger) {
  (0, _inherits3.default)(Base, _Logger);

  /// @name constructor
  /// @arg {object} options - Global options for the different classes
  /// @raw-code
  function Base() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Base);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Base.__proto__ || (0, _getPrototypeOf2.default)(Base)).call(this, options));

    var root = process.cwd();
    _this.options = _toJs2.default.extend({
      root: root,
      log: true,
      verbose: false,
      spinners: true,
      timestamp: true
    }, _this.options || {});
    _this.options = _toJs2.default.extend(_this.options, options);

    _this.options.root = _path2.default.resolve(root, _this.options.root);

    if (_this.options.verbose) {
      _this.options.log = true;
    }

    if (!_this.options.log) {
      _this.options.spinners = false;
    }
    return _this;
  }

  ///# @name resolvePaths
  ///# @description
  ///# This is ued to parsed paths that are passed to the different functions
  ///# @arg {string, array} paths - The paths to normalize
  ///# @arg {string} root [this.options.root] - This is the base that will resolve other paths


  (0, _createClass3.default)(Base, [{
    key: 'resolvePaths',
    value: function resolvePaths(paths) {
      var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.options.root;

      if (!paths) {
        return [];
      }
      return _toJs2.default.string(paths, ', ').split(/\s*(?:,| )\s*/).filter(Boolean).map(function (file) {
        if (_path2.default.isAbsolute(file)) {
          return file;
        }
        return _path2.default.join(root, file);
      });
    }
  }]);
  return Base;
}(_logger2.default);

exports.default = Base;
//# sourceMappingURL=base.js.map